%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0
%global service cinder

%global common_desc \
OpenStack Volume (codename Cinder) provides services to manage and \
access block storage volumes for use by Virtual Machine instances.

Name:             openstack-%{service}
# Liberty semver reset
# https://review.openstack.org/#/q/I6a35fa0dda798fad93b804d00a46af80f08d475c,n,z
Epoch:            1
Version:          12.0.10
Release:          25%{?dist}
Summary:          OpenStack Volume service

License:          ASL 2.0
URL:              http://www.openstack.org/software/openstack-storage/
Source0:          https://tarballs.openstack.org/%{service}/%{service}-%{upstream_version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=12.0.10
Patch0001: 0001-RBD-Enable-cinder-exclusive-pool-by-default.patch
Patch0002: 0002-Dell-EMC-SC-Enabled-multiattach-in-Storage-Center-Dr.patch
Patch0003: 0003-XtremIO-support-multiattach.patch
Patch0004: 0004-Unity-add-multiattach-support.patch
Patch0005: 0005-HPE-3PAR-Added-support-for-multiattach-feature-in-hp.patch
Patch0006: 0006-NetApp-SolidFire-Revert-volume-to-snapshot.patch
Patch0007: 0007-HPE-3PAR-Fix-detach-of-multiattach-volumes.patch
Patch0008: 0008-RBD-add-support-for-multiattach.patch
Patch0009: 0009-Move-RBD-driver-exception-to-driver.patch
Patch0010: 0010-RBD-save-and-restore-multiattach-features.patch
Patch0011: 0011-Fix-DetachedInstanceError-for-VolumeAttachment.patch
Patch0012: 0012-Dell-EMC-SC-Handle-the-mappings-of-multiattached-vol.patch
Patch0013: 0013-Fix-remotefs-clone-volume-locking.patch
Patch0014: 0014-RemoteFS-Use-dest-vol-id-instead-of-source-id-in-sna.patch
Patch0015: 0015-Increase-cpu-limit-for-image-conversion.patch
Patch0016: 0016-Add-support-for-VxFlex-OS-3.0.x.patch
Patch0017: 0017-Unity-add-thick-volume-support.patch
Patch0018: 0018-Unity-Compressed-volume-support.patch
Patch0019: 0019-Fix-Create-new-cache-entry-when-xtremio-reaches-snap.patch
Patch0020: 0020-XtremIO-Remove-provisioning-factor-when-reporting.patch
Patch0021: 0021-RBD-fix-volume-reference-handling-in-clone-logic.patch
Patch0022: 0022-Make-volume-soft-delete-more-thorough.patch
Patch0023: 0023-NetApp-SolidFire-Fix-NetApp-SolidFire-SSL-option.patch
Patch0024: 0024-Update-in-tree-Datera-Cinder-driver.patch
Patch0025: 0025-ScaleIO-Fix-volumes-created-from-snapshot-are-not-us.patch
Patch0026: 0026-Configurable-timeout-of-the-QEMU-img-conversion.patch
Patch0027: 0027-ChunkedBackupDriver-Freeing-memory-on-restore.patch
Patch0028: 0028-Cap-sphinx-for-py2-to-match-global-reqs.patch
Patch0029: 0029-PowerMax-Driver-Legacy-volume-not-found.patch
Patch0030: 0030-3PAR-Fix-renaming-volume-after-migration.patch
Patch0031: 0031-Creating-image-volume-cache-on-NFS-backend-fails.patch
Patch0032: 0032-Remove-VxFlex-OS-credentials-from-connection_propert.patch
Patch0033: 0033-VMAX-Driver-Queens-FC-live-migration-failure.patch
Patch0034: 0034-NetApp-ONTAP-Fix-iSCSI-multiattach-volume-terminates.patch
Patch0035: 0035-3PAR-Fix-live-migration.patch
Patch0036: 0036-RBD-Cleanup-temporary-file-during-exception.patch
Patch0037: 0037-NEC-driver-fix-an-undefined-variable.patch
Patch0038: 0038-Unity-Fix-TypeError-for-test-case-test_delete_host_w.patch
Patch0039: 0039-Change-check_uptodate.sh-to-not-call-tox.patch
Patch0040: 0040-tintri-Enable-SSL-with-requests.patch
Patch0041: 0041-nimble-Fix-missing-ssl-support.patch
Patch0042: 0042-Fix-service_uuid-migration-for-volumes-with-no-host.patch
Patch0043: 0043-VNX-delete-the-LUN-from-VNX-backend.patch
Patch0044: 0044-Creating-snapshot-on-NFS-backend-fails.patch
Patch0045: 0045-RBD-Run-flatten-in-a-different-thread-when-cloning-a.patch
Patch0046: 0046-Do-not-fail-when-depth-is-greater-than-rbd_max_clone.patch
Patch0047: 0047-3PAR-Provide-an-option-duing-creation-of-volume-from.patch
Patch0048: 0048-NetApp-SolidFire-Fix-clone-and-request-timeout-issue.patch
Patch0049: 0049-NetApp-SolidFire-Fix-duplicate-volume-when-API-respo.patch
Patch0050: 0050-NetApp-SolidFire-Fix-error-on-cluster-workload-rebal.patch
Patch0051: 0051-NFS-Update-connection-info-on-online-snap-create.patch
Patch0052: 0052-rbd-Fix-create-encrypted-volume-from-snapshot.patch

Source1:          %{service}-dist.conf
Source2:          %{service}.logrotate

Source10:         openstack-%{service}-api.service
Source11:         openstack-%{service}-scheduler.service
Source12:         openstack-%{service}-volume.service
Source13:         openstack-%{service}-backup.service
Source20:         %{service}-sudoers


BuildArch:        noarch
BuildRequires:    intltool
BuildRequires:    python2-openstackdocstheme
BuildRequires:    python2-pbr
BuildRequires:    python2-reno
BuildRequires:    python2-sphinx
BuildRequires:    python2-devel
BuildRequires:    python2-setuptools
BuildRequires:    python2-netaddr
BuildRequires:    systemd
BuildRequires:    git
BuildRequires:    openstack-macros
BuildRequires:    os-brick
BuildRequires:    python2-pyparsing
BuildRequires:    python2-pytz
BuildRequires:    python-decorator
BuildRequires:    openstack-macros
# Required to build cinder.conf
BuildRequires:    python-google-api-client >= 1.4.2
BuildRequires:    python2-keystonemiddleware
BuildRequires:    python2-glanceclient >= 2.8.0
BuildRequires:    python2-novaclient >= 9.1.0
BuildRequires:    python2-swiftclient >= 3.2.0
BuildRequires:    python2-oslo-db
BuildRequires:    python2-oslo-config >= 2:5.1.0
BuildRequires:    python2-oslo-policy
BuildRequires:    python2-oslo-reports
BuildRequires:    python2-oslotest
BuildRequires:    python2-oslo-utils
BuildRequires:    python2-oslo-versionedobjects
BuildRequires:    python2-oslo-vmware
BuildRequires:    python2-os-win
BuildRequires:    python2-castellan
BuildRequires:    python2-cryptography
BuildRequires:    python-lxml
BuildRequires:    python2-osprofiler
BuildRequires:    python2-paramiko
BuildRequires:    python2-suds
BuildRequires:    python2-taskflow
BuildRequires:    python2-tooz
BuildRequires:    python2-oslo-log
BuildRequires:    python2-oslo-i18n
BuildRequires:    python2-barbicanclient
BuildRequires:    python2-requests
BuildRequires:    python-retrying
BuildRequires:    python2-defusedxml

# Required to compile translation files
BuildRequires:    python2-babel

# Needed for unit tests
BuildRequires:    python2-ddt
BuildRequires:    python2-fixtures
BuildRequires:    python2-mock
BuildRequires:    python2-oslotest
BuildRequires:    python2-subunit
BuildRequires:    python2-testtools
BuildRequires:    python2-testrepository
BuildRequires:    python2-testresources
BuildRequires:    python2-testscenarios
BuildRequires:    python2-os-testr
BuildRequires:    python-rtslib

Requires:         python-%{service} = %{epoch}:%{version}-%{release}

# we dropped the patch to remove PBR for Delorean
Requires:         python2-pbr

# as convenience
Requires:         python2-cinderclient

%{?systemd_requires}
Requires(pre):    shadow-utils

Requires:         lvm2
Requires:         python2-osprofiler
Requires:         python-rtslib
Requires:         python-pyudev

# required for cinder-manage
Requires:         python-prettytable >= 0.7.1

%description
%{common_desc}


%package -n       python-%{service}
Summary:          OpenStack Volume Python libraries
Group:            Applications/System

Requires:         sudo

Requires:         qemu-img
Requires:         sysfsutils
Requires:         os-brick >= 2.1.1
Requires:         python2-paramiko >= 2.0
Requires:         python-simplejson >= 3.5.1
Requires:         python2-jsonschema >= 2.6.0
Requires:         python2-os-win >= 3.0.0
Requires:         python2-oslo-vmware >= 2.17.0

Requires:         python2-castellan >= 0.16.0
Requires:         python2-eventlet >= 0.18.2
Requires:         python2-greenlet >= 0.4.10
Requires:         python2-iso8601 >= 0.1.11
Requires:         python-lxml >= 3.2.1
Requires:         python2-stevedore >= 1.20.0
Requires:         python2-suds
Requires:         python2-tooz >= 1.58.0

Requires:         python2-sqlalchemy >= 1.0.10
Requires:         python-migrate >= 0.11.0

Requires:         python-paste
Requires:         python-paste-deploy
Requires:         python2-routes >= 2.3.1
Requires:         python-webob >= 1.7.1

Requires:         python2-glanceclient >= 1:2.8.0
Requires:         python2-swiftclient >= 3.2.0
Requires:         python2-keystoneclient >= 1:3.8.0
Requires:         python2-novaclient >= 9.1.0

Requires:         python2-oslo-config >= 2:5.1.0
Requires:         python2-six >= 1.10.0
Requires:         python2-psutil >= 3.2.2

Requires:         python2-babel
Requires:         python-google-api-client >= 1.4.2

Requires:         python2-oslo-rootwrap >= 5.8.0
Requires:         python2-oslo-utils >= 3.33.0
Requires:         python2-oslo-serialization >= 2.18.0
Requires:         python2-oslo-db >= 4.27.0
Requires:         python2-oslo-context >= 2.19.2
Requires:         python2-oslo-concurrency >= 3.25.0
Requires:         python2-oslo-middleware >= 3.31.0
Requires:         python2-taskflow >= 2.16.0
Requires:         python2-oslo-messaging >= 5.29.0
Requires:         python2-oslo-policy >= 1.30.0
Requires:         python2-oslo-reports >= 1.18.0
Requires:         python2-oslo-service >= 1.24.0
Requires:         python2-oslo-versionedobjects >= 1.31.2

Requires:         iscsi-initiator-utils

Requires:         python2-osprofiler >= 1.4.0

Requires:         python-httplib2 >= 0.9.1
Requires:         python2-oauth2client >= 1.5.0

Requires:         python2-oslo-log >= 3.36.0
Requires:         python2-oslo-i18n >= 3.15.3
Requires:         python2-barbicanclient >= 4.0.0
Requires:         python2-requests >= 2.14.2
Requires:         python-retrying >= 1.2.3
Requires:         python2-pyparsing >= 2.1.0
Requires:         python2-pytz
Requires:         python-decorator
Requires:         python-enum34
Requires:         python-ipaddress

Requires:         python2-keystonemiddleware >= 4.17.0
Requires:         python2-keystoneauth1 >= 3.3.0

Requires:         python2-oslo-privsep >= 1.23.0

Requires:         python2-cryptography >= 1.7.2

Requires:         python2-defusedxml >= 0.5.0

%description -n   python-%{service}
%{common_desc}

This package contains the %{service} Python library.

%package -n python-%{service}-tests
Summary:        Cinder tests
Requires:       openstack-%{service} = %{epoch}:%{version}-%{release}

# Added test requirements
Requires:       python2-hacking
Requires:       python-anyjson
Requires:       python2-ddt
Requires:       python2-fixtures
Requires:       python2-mock
Requires:       python2-mox3
Requires:       python2-oslotest
Requires:       python2-subunit
Requires:       python2-testtools
Requires:       python2-testrepository
Requires:       python2-testresources
Requires:       python2-testscenarios
Requires:       python2-os-testr

%description -n python-%{service}-tests
%{common_desc}

This package contains the Cinder test files.

%if 0%{?with_doc}
%package doc
Summary:          Documentation for OpenStack Volume
Group:            Documentation

Requires:         %{name} = %{epoch}:%{version}-%{release}

BuildRequires:    graphviz

# Required to build module documents
BuildRequires:    python2-eventlet
BuildRequires:    python2-routes
BuildRequires:    python2-sqlalchemy
BuildRequires:    python-webob
# while not strictly required, quiets the build down when building docs.
BuildRequires:    python-migrate
BuildRequires:    python2-iso8601 >= 0.1.9

%description      doc
%{common_desc}

This package contains documentation files for %{service}.
%endif

%prep
%autosetup -n %{service}-%{upstream_version} -S git

find . \( -name .gitignore -o -name .placeholder \) -delete

find %{service} -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

sed -i 's/%{version}.%{milestone}/%{version}/' PKG-INFO

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup

%build
# Generate config file
PYTHONPATH=. oslo-config-generator --config-file=tools/config/%{service}-config-generator.conf

# Build
%{__python2} setup.py build

# Generate i18n files
# (amoralej) we can remove '-D cinder' once https://review.openstack.org/#/c/439501/ is merged
%{__python2} setup.py compile_catalog -d build/lib/%{service}/locale -D cinder

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# docs generation requires everything to be installed first
export PYTHONPATH="$( pwd ):$PYTHONPATH"

%if 0%{?with_doc}
%{__python2} setup.py build_sphinx --builder html
# Fix hidden-file-or-dir warnings
rm -fr doc/build/html/.buildinfo
%endif

%{__python2} setup.py build_sphinx --builder man
mkdir -p %{buildroot}%{_mandir}/man1
install -p -D -m 644 doc/build/man/*.1 %{buildroot}%{_mandir}/man1/

# Setup directories
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}/tmp
install -d -m 755 %{buildroot}%{_localstatedir}/log/%{service}

# Install config files
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}
install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datadir}/%{service}/%{service}-dist.conf
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/volumes
install -p -D -m 640 etc/%{service}/rootwrap.conf %{buildroot}%{_sysconfdir}/%{service}/rootwrap.conf
install -p -D -m 640 etc/%{service}/api-paste.ini %{buildroot}%{_sysconfdir}/%{service}/api-paste.ini
install -p -D -m 640 etc/%{service}/%{service}.conf.sample %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf

# Install initscripts for services
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/openstack-%{service}-api.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/openstack-%{service}-scheduler.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/openstack-%{service}-volume.service
install -p -D -m 644 %{SOURCE13} %{buildroot}%{_unitdir}/openstack-%{service}-backup.service

# Install sudoers
install -p -D -m 440 %{SOURCE20} %{buildroot}%{_sysconfdir}/sudoers.d/%{service}

# Install logrotate
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-%{service}

# Install pid directory
install -d -m 755 %{buildroot}%{_localstatedir}/run/%{service}

# Install rootwrap files in /usr/share/cinder/rootwrap
mkdir -p %{buildroot}%{_datarootdir}/%{service}/rootwrap/
install -p -D -m 644 etc/%{service}/rootwrap.d/* %{buildroot}%{_datarootdir}/%{service}/rootwrap/


# Symlinks to rootwrap config files
mkdir -p %{buildroot}%{_sysconfdir}/%{service}/rootwrap.d
for filter in %{_datarootdir}/os-brick/rootwrap/*.filters; do
ln -s $filter %{buildroot}%{_sysconfdir}/%{service}/rootwrap.d/
done

# Install i18n .mo files (.po and .pot are not required)
install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python2_sitelib}/%{service}/locale/*/LC_*/%{service}*po
rm -f %{buildroot}%{python2_sitelib}/%{service}/locale/*pot
mv %{buildroot}%{python2_sitelib}/%{service}/locale %{buildroot}%{_datadir}/locale

# Find language files
%find_lang %{service} --all-name

# Remove unneeded in production stuff
rm -f %{buildroot}/usr/share/doc/%{service}/README*

# Remove duplicate config files under /usr/etc/
rm -rf %{buildroot}%{_prefix}/etc

# FIXME(jpena): unit tests are taking too long in the current DLRN infra
# Until we have a better architecture, let's not run them when under DLRN
%if 0%{!?dlrn}
%check
OS_TEST_PATH=./%{service}/tests/unit ostestr --concurrency=2
%endif

%pre
getent group %{service} >/dev/null || groupadd -r %{service} --gid 165
if ! getent passwd %{service} >/dev/null; then
  useradd -u 165 -r -g %{service} -G %{service},nobody -d %{_sharedstatedir}/%{service} -s /sbin/nologin -c "OpenStack Cinder Daemons" %{service}
fi
exit 0

%post
%systemd_post openstack-%{service}-volume
%systemd_post openstack-%{service}-api
%systemd_post openstack-%{service}-scheduler
%systemd_post openstack-%{service}-backup

%preun
%systemd_preun openstack-%{service}-volume
%systemd_preun openstack-%{service}-api
%systemd_preun openstack-%{service}-scheduler
%systemd_preun openstack-%{service}-backup

%postun
%systemd_postun_with_restart openstack-%{service}-volume
%systemd_postun_with_restart openstack-%{service}-api
%systemd_postun_with_restart openstack-%{service}-scheduler
%systemd_postun_with_restart openstack-%{service}-backup

%files
%dir %{_sysconfdir}/%{service}
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/api-paste.ini
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/rootwrap.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-%{service}
%config(noreplace) %{_sysconfdir}/sudoers.d/%{service}
%{_sysconfdir}/%{service}/rootwrap.d/
%attr(-, root, %{service}) %{_datadir}/%{service}/%{service}-dist.conf

%dir %attr(0750, %{service}, root) %{_localstatedir}/log/%{service}
%dir %attr(0755, %{service}, root) %{_localstatedir}/run/%{service}
%dir %attr(0755, %{service}, root) %{_sysconfdir}/%{service}/volumes

%{_bindir}/%{service}-*
%{_unitdir}/*.service
%{_datarootdir}/%{service}
%{_mandir}/man1/%{service}*.1.gz

%defattr(-, %{service}, %{service}, -)
%dir %{_sharedstatedir}/%{service}
%dir %{_sharedstatedir}/%{service}/tmp

%files -n python-%{service} -f %{service}.lang
%{?!_licensedir: %global license %%doc}
%license LICENSE
%{python2_sitelib}/%{service}
%{python2_sitelib}/%{service}-*.egg-info
%exclude %{python2_sitelib}/%{service}/test.py
%exclude %{python2_sitelib}/%{service}/tests

%files -n python-%{service}-tests
%license LICENSE
%{python2_sitelib}/%{service}/test.py
%{python2_sitelib}/%{service}/tests

%if 0%{?with_doc}
%files doc
%doc doc/build/html
%endif

%changelog
* Wed Aug 18 2021 Sofia Enriquez <senrique@redhat.com> 1:12.0.10-25
- [rbd] Fix create encrypted volume from snapshot (rhbz#1956762)

* Wed Jul 28 2021 Eric Harney <eharney@redhat.com> 1:12.0.10-24
- NFS: Update connection info on online snap create (rhbz#1977845)

* Mon Apr 19 2021 Pablo Caruana <pcaruana@redhat.com> 1:12.0.10-23
- NetApp SolidFire: Fix error on cluster workload rebalancing (rhbz#1888417)
- NetApp SolidFire: Fix duplicate volume when API response is lost (rhbz#1914590)
- NetApp SolidFire: Fix clone and request timeout issues (rhbz#1888469)
- 3PAR: Provide an option duing creation of volume from snapshot (rhbz#1940153)

* Mon Apr 12 2021 Pablo Caruana <pcaruana@redhat.com> 1:12.0.10-22
- 3PAR: Provide an option duing creation of volume from snapshot (rhbz#1940153)

* Mon Nov 02 2020 Eric Harney <eharney@redhat.com> 1:12.0.10-21
- Do not fail when depth is greater than rbd_max_clone_depth (rhbz#1889894)

* Thu Oct 15 2020 Eric Harney <eharney@redhat.com> 1:12.0.10-20
- RBD: Run flatten in a different thread when cloning a volume (rhbz#1885734)

* Fri Aug 28 2020 Rajat <rdhasman@redhat.com> 1:12.0.10-19
- Creating snapshot on NFS backend fails (rhbz#1843088)

* Thu Aug 20 2020 Miguel Garcia <mgarciac@redhat.com> 1:12.0.10-18
- VNX: delete the LUN from VNX backend
- Fix service_uuid migration for volumes with no host
- nimble: Fix missing ssl support
- tintri: Enable SSL with requests
- Change check_uptodate.sh to not call tox
- [Unity] Fix TypeError for test case test_delete_host_wo_lock
- NEC driver: fix an undefined variable
- RBD: Cleanup temporary file during exception (rhbz#1812988)

* Tue Jul 28 2020 Gorka Eguileor <geguileo@redhat.com> 1:12.0.10-17
- 3PAR: Fix live migration (RHBZ#1841866)

* Tue Jul 14 2020 Alan Bishop <abishop@redhat.com> 1:12.0.10-16
- NetApp ONTAP: Fix iSCSI multiattach volume terminates connection (rhbz#1854210)

* Tue Jun 16 2020 Pablo Caruana <pcaruana@redhat.com> 1:12.0.10-15
- VMAX Driver Queens - FC live migration failure (rhbz#1841157)

* Mon Jun 15 2020 Brian Rosmaita <brosmait@redhat.com> 1:12.0.10-14
- Remove VxFlex OS credentials from connection_properties (rhbz#1842749)

* Wed Jun 03 2020 Rajat <rdhasman@redhat.com> 1:12.0.10-13
- Update patches

* Wed Jun 03 2020 Rajat <rdhasman@redhat.com> 1:12.0.10-12
- Creating image-volume cache on NFS backend fails (rhbz#1843088)

* Thu May 21 2020 Alan Bishop <abishop@redhat.com> 1:12.0.10-11
- 3PAR - Fix renaming volume after migration (rhbz#1835870)

* Wed May 06 2020 Miguel Garcia <mgarciac@redhat.com> 1:12.0.10-10
- PowerMax Driver - Legacy volume not found
- Cap sphinx for py2 to match global reqs

* Mon May 04 2020 Eric Harney <eharney@redhat.com> 1:12.0.10-9
- ChunkedBackupDriver: Freeing memory on restore (rhbz#1806975)
- Configurable timeout of the QEMU img conversion (rhbz#1796694)

* Thu Apr 30 2020 Alan Bishop <abishop@redhat.com> 1:12.0.10-8
- ScaleIO: Fix volumes created from snapshot are not usable (rhbz#1829284)

* Mon Apr 27 2020 Alan Bishop <abishop@redhat.com> 1:12.0.10-7
- Update in-tree Datera Cinder driver (rhbz#1823416)

* Tue Mar 24 2020 Eric Harney <eharney@redhat.com> 1:12.0.10-6
- NetApp SolidFire: Fix NetApp SolidFire SSL option

* Mon Mar 23 2020 Rajat <rdhasman@redhat.com> 1:12.0.10-5
- Make volume soft delete more thorough (rhbz#1777906)

* Fri Mar 20 2020 Alan Bishop <abishop@redhat.com> 1:12.0.10-4
- RBD: fix volume reference handling in clone logic (rhbz#1811587)
- [XtremIO] Remove provisioning factor when reporting (rhbz#1811122)

* Wed Mar 04 2020 Rajat <rdhasman@redhat.com> 1:12.0.10-3
- Fix: Create new cache entry when xtremio reaches snap limit

* Thu Jan 30 2020 Eric Harney <eharney@redhat.com> 1:12.0.10-2
- [Unity] Compressed volume support
- Unity: add thick volume support

* Tue Jan 28 2020 Miguel Garcia <mgarciac@redhat.com> 1:12.0.10-1
- Update to 12.0.10

* Fri Jan 17 2020 Eric Harney <eharney@redhat.com> 1:12.0.8-6
- Add support for VxFlex OS 3.0.x

* Tue Dec 03 2019 Eric Harney <eharney@redhat.com> 1:12.0.8-5
- Increase cpu limit for image conversion (rhbz#1764545)

* Mon Nov 25 2019 Eric Harney <eharney@redhat.com> 1:12.0.8-4
- Fix remotefs clone volume locking (rhbz#1741730)

* Fri Oct 11 2019 Alan Bishop <abishop@redhat.com> 1:12.0.8-3
- Add context to cloning snapshots in remotefs driver (rhbz#1714805)

* Fri Oct 04 2019 Alan Bishop <abishop@redhat.com> 1:12.0.8-2
- Dell EMC SC: Handle the mappings of multiattached volume (rhbz#1705757)
- Fix DetachedInstanceError for VolumeAttachment (rhbz#1705757)

* Wed Oct 02 2019 Steve Linabery <slinaber@redhat.com> 1:12.0.8-1
- Update to 12.0.8
- RBD: remove redundant exception log to reduce noise
- Fix VolumeAttachment is not bound to a Session
- Remove experimental openSUSE 42.3 job
- Remove Sheepdog tests from zuul config

* Fri Sep 06 2019 Alan Bishop <abishop@redhat.com> 1:12.0.7-6
- Fix NFS volume retype with migrate (rhbz#1740560)

* Tue Aug 13 2019 Eric Harney <eharney@redhat.com> 1:12.0.7-5
- RBD: save and restore multiattach features (rhbz#1700882)
- RBD: add support for multiattach (rhbz#1700882)
- Prevent double-attachment race in attachment_reserve (rhbz#1705563)

* Fri Jul 19 2019 Alan Bishop <abishop@redhat.com> 1:12.0.7-4
- HPE 3PAR - Fix detach of multiattach volumes (rhbz#1725012)

* Tue Jun 25 2019 Pablo Caruana <pcaruana@redhat.com> 1:12.0.7-3
- Create new image volume cache entry when cloning fails (rhbz#1717727)

* Tue Jun 11 2019 Eric Harney <eharney@redhat.com> 1:12.0.7-2
- lvm: Only use initiators when comparing connector dicts (rhbz #1701172)

* Tue Jun 04 2019 Steve Linabery <slinaber@redhat.com> 1:12.0.7-1
- Update to 12.0.7
- Dell EMC: SC FC Driver wwns api response in lower
- Remove LOCI publishing from the post pipeline
- NetApp SolidFire: Fix multi-attach volume deletion

* Fri May 24 2019 Sofia Enriquez <senrique@redhat.com> 1:12.0.6-6
- HPE 3PAR-Added support for multiattach feature in hpe3par cinder driver (rhbz#1708705)

* Fri May 24 2019 Pablo Caruana <pcaruana@redhat.com> 1:12.0.6-5
- NetApp: Return all iSCSI targets-portals (rhbz#1697996)

* Wed May 15 2019 Sofia Enriquez <senrique@redhat.com> 1:12.0.6-4
- Change the matching method of the backup driver (rhbz#1688098)

* Mon Apr 08 2019 Eric Harney <eharney@redhat.com> 1:12.0.6-3
- Unity: add multiattach support
- XtremIO: support multiattach
- Dell EMC SC: Enabled multiattach in Storage Center Driver

* Sat Apr 06 2019 Sofia Enriquez <senrique@redhat.com> 1:12.0.6-2
- Check Volume Status on attachment create/update
- Handle multiattach attribute when managing volumes (rhbz#1692542)
- Set right attach mode after migration (rhbz#1692542)
- Correct attachment create success response code (rhbz#1692542)

* Fri Apr 05 2019 Jon Schlueter <jschluet@redhat.com> 1:12.0.6-1
- Update to 12.0.6 (rhbz#1696662)
- VNX Driver: delete_hba() instead of remove_hba()  (rhbz#1684208)
- VNX: update sg in cache (rhbz#1693338)

* Thu Mar 21 2019 Eric Harney <eharney@redhat.com> 1:12.0.4-10
- Fix Snapshot object metadata loading (rhbz#1628068)

* Tue Feb 26 2019 Sofia Enriquez <senrique@redhat.com> 1:12.0.4-9
- Fix for HPE MSA 2050 login failures (rhbz#1676603)

* Mon Jan 28 2019 Steve Linabery <slinaber@redhat.com> 1:12.0.4-8
- Add secret=true to fixed_key configuration parameter
- Retry on DBDeadLock affecting worker updates
- Consume quota when importing backup resource
- Handle rbd.OSError on broken RBD image
- Stop cleaning images to be deleted in remotefs driver
- Correct default policy file
- Remove cinder-tox-compliance job
- lvm: Avoid premature calls to terminate_connection for muiltiattach vols
- LVM: Disable multiattach for LIO iSCSI target
- Fix non iSCSI attach serialization
- SF ensure the correct volume is deleted

* Fri Jan 25 2019 Brian Rosmaita <brosmait@redhat.com> 1:12.0.4-7
- cinder-volume: Stop masking IOError different than ENOSPC (rhbz#1659264)

* Thu Jan 24 2019 Brian Rosmaita <brosmait@redhat.com> 1:12.0.4-6
- VMAX Driver - VMAX OS Upgrade Bug (rhbz#1664391)

* Fri Jan 11 2019 Lee Yarwood <lyarwood@redhat.com> 1:12.0.4-5
- lvm: Avoid premature calls to terminate_connection for muiltiattach vols (rhbz#1650429)

* Mon Jan 07 2019 Laura Sofia Enriquez <senrique@redhat.com> 1:12.0.4-4
- Ensure image utils don't block greenthreads (rhbz#1646940)

* Mon Nov 26 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.4-3
- Storwize: modify hyperswap host_site configuration
- Fix backup/restore error for ceph rbd backend
- VMAX Queens - 90 endpoint not compatible with unisphere 8.4
- Handling type's multiattach extra specs in API task flow

* Tue Oct 23 2018 Alan Bishop <abishop@redhat.com> 1:12.0.4-2
- nimble storage: support for force detach (rhbz#1640834)

* Tue Oct 16 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.4-1
- Update to 12.0.4 (rhbz#1639941)

* Mon Oct 15 2018 Elise Gafford <egafford@redhat.com> 1:12.0.3-7
- ScaleIO: Prevent usage of unsafe volumes (rhbz#1610148)

* Mon Oct 15 2018 Alan Bishop <abishop@redhat.com> 1:12.0.3-6
- NetApp SolidFire: Fix CG snapshot deletion (rhbz#1629049)
- NetApp SolidFire: Fix force_detach (rhbz#1638406)

* Tue Oct 09 2018 Brian Rosmaita <brosmait@redhat.com> 1:12.0.3-5
- Fix IPv6 for Cinder NetApp ONTAP drivers (rhbz#1635620)

* Tue Sep 04 2018 Elise Gafford <egafford@redhat.com> 1:12.0.3-4
- RBD: Enable cinder exclusive pool by default (rhbz#1624482)

* Fri Aug 31 2018 Elise Gafford <egafford@redhat.com> 1:12.0.3-3
- NetApp ONTAP: Fix driver force detach operations (rhbz#1622535)

* Wed Jul 18 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.3-2
- Fix RBD incremental backup
- NEC driver: Reuse iSCSI LUNs of detached volumes.
- NEC driver: Delete max volumes per pool limit.
- Fix quota error when deleting temporary volume (rhbz#1597735)
- GoodnessWeigher schedules non-type volumes
- HPE3PAR: Fix pointing to backend in group failover
- Storwize: self assign the SCSI lun id for volume attaching
- Storwize: filter active wwpns for NPIV
- [Unity] Return logged-out initiators
- ZFSSA handle non-existent snapshot
- Correct S-Series to DS-Series systems
- Update storage backends supported for Lenovo

* Mon Jun 18 2018 RDO <dev@lists.rdoproject.org> 1:12.0.3-1
- Update to 12.0.3

* Tue Jun  5 2018 Alan Bishop <abishop@redhat.com> 1:12.0.2-2
- Do not repeat log messages on stderr

* Mon Jun 04 2018 RDO <dev@lists.rdoproject.org> 1:12.0.2-1
- Update to 12.0.2

* Thu May 31 2018 Eric Harney <eharney@redhat.com> 1:12.0.1-0.20180418194614.c476898
- Fix handling of 'cinder_encryption_key_id' image metadata

* Thu Apr 26 2018 Eric Harney <eharney@redhat.com> 1:12.0.1-0.20180418194613.c476898
- Add Keystone v3 domain information to context

* Wed Apr 25 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.1-0.20180418194612.c476898
- Avoid second restart on offline upgrades (rhbz#1557331)

